import { Component, createRef, h } from "preact";
import { Router } from "preact-router";
import Header from "./header";
import Login from "../routes/login";
import Profile from "../routes/profile";
import Menu from "./menu";
import Users from "../routes/users";
import { useCallback, useState } from "preact/hooks";
const menu = createRef();
class App extends Component {
  toggleMenu() {
    const [visible, setValue] = useState(false);
    const toggle = useCallback(() => {
      setValue(!visible);
      return !visible;
    }, [visible]);
    return { visible, toggle };
  }
  authenticateUser() {
    const [session, setValue] = useState({ token: null });
    const login = (username, password) => {
      if (username == "admin" && password == "admin") {
        setValue({ ...session, token: "ABCDEFG" });
        return true;
      }
    };
    const logout = () => setValue({ ...session, token: null });
    const isAuthenticated = () => session.token != null;
    return { login, logout, isAuthenticated };
  }

  render() {
    const menu = this.toggleMenu();
    const auth = this.authenticateUser();
    return (
      <div id="wrapper">
        <Header menu={menu} auth={auth} />
        <Menu menu={menu} />
        {!menu.visible &&
          (!auth.isAuthenticated() ? (
            <Login auth={auth} />
          ) : (
            <div class="page">
              <Router>
                <Profile path="/test/" user="me" />
                <Profile path="/profile/:user" />
                <Users path="/users" />
                <div class="container" default>Error 404</div>
              </Router>
            </div>
          ))}
      </div>
    );
  }
}

export default App;
