import { Component, h } from 'preact';
import Breadcrumbs from '../../components/breadcrumbs';

class Login extends Component {
    state = { username: '', password: '' };
    navigation = ["Login"];
    onSubmit = (e) => {
        e.preventDefault();
        console.log(this.state);
        this.setState({ username: '', password: '' });
        if(!this.props.auth.login(this.state.username,this.state.password))
            alert("Wrong login")
    }

    render() {

        return (<div id="login-screen" class="page">
            <div class="container">
                <Breadcrumbs items={this.navigation} />

                <form id="login_form" onSubmit={this.onSubmit} >
                    <p>
                        Bitte melden Sie sich mit ihren Nutzerdaten an.
                    </p>
                    <div class="input-box">
                        <input id="name" type="text" placeholder="Username" onInput={e => this.setState(prev => ({ ...prev, username: e.target.value }))} value={this.state.username} />
                        <label for="name">Benutzername</label>
                    </div>
                    <div class="input-box">
                        <input id="pass" type="password" placeholder="Passwort" onInput={e => this.setState(prev => ({ ...prev, password: e.target.value }))} value={this.state.password} />
                        <label for="pass">Password</label>
                    </div>
                    <input type="submit" value="Submit" />

                </form>
            </div>
        </div>);
    }
}

export default Login;